ObjectArx图层相关函数

选择指定图层上的所有实体

Acad::ErrorStatus selectEntityInLayer(const std::wstring sLayerName, AcDbObjectIdArray& nIDs)
{
	Acad::ErrorStatus es = Acad::eOk;

	ads_name ents;
	struct resbuf *rb;
	rb = acutNewRb(AcDb::kDxfLayerName);
	rb->restype = 8;
	rb->resval.rstring = (ACHAR *)sLayerName.c_str();
	rb->rbnext = NULL;
	acedSSGet(L"X", NULL, NULL, rb, ents);
	Adesk::Int32 entNums = 0;
	acedSSLength(ents, &entNums);
	if (entNums == 0)
		es = Acad::eInvalidInput;
	else
	{
		for (long a = 0; a < entNums; a++)
		{
			AcDbObjectId objId;
			ads_name      ent;
			acedSSName(ents, a, ent);
			acdbGetObjectId(objId, ent);
			nIDs.append(objId);
		}
	}
	acedSSFree(ents);
	acutRelRb(rb);
	return es;
}

设置当前层

Acad::ErrorStatus SetCurLayer(const std::wstring lpLayerName, AcDbDatabase* pDb/* = NULL */)
{
	AcDbDatabase* pCurDb = pDb;
	if (pCurDb == NULL)
	{
		pCurDb = acdbHostApplicationServices()->workingDatabase();
	}

	AcDbLayerTableRecordPointer spRecord(lpLayerName.c_str(), pCurDb, AcDb::kForRead);
	Acad::ErrorStatus es = spRecord.openStatus();
	if (es == Acad::eOk)
	{
		es = pCurDb->setClayer(spRecord->objectId());
	}
	return es;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

码农709

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值